Program TextEditor; 
var 
   CurLine,CurRow : integer; 
   EditText : array [1..20] of string; 
   src,kod,atr : integer; 
   j : integer; 
   ts : string; 

procedure WriteLine( LineN:integer ); 
var 
   i : integer; 
begin 
  rectangle( 0,(LineN-1)*30,600,LineN*30 ); 
  for i:=1 to length(EditText[LineN]) do 
    begin 
      moveto(i*20-16,(LineN-1)*30); 
      write( EditText[LineN][i] ) 
    end 
end; 

procedure MoveCursor( row,lin : integer ); 
begin 
  if lin > 20 then 
    lin := 20; 
  if lin < 1 then 
    lin := 1; 
  if row < 1 then 
    row := 1; 
  if row > length(EditText[lin])+1 then 
    row := length(EditText[lin])+1; 
  Pen(2,255,255,255); 
  line( CurRow*20-18,CurLine*30-30,CurRow*20-18,CurLine*30-1); 
  CurLine := lin; 
  CurRow := row; 
  Pen(2,255,0,0); 
  line( CurRow*20-18,CurLine*30-30,CurRow*20-18,CurLine*30-1); 
  Pen(1,255,255,255); 
end; 

Begin 
  font(15,0,800); 
  textcolor(0,0,255); 
  Pen(1,255,255,255); 
  Brush(1,255,255,255); 
  for j:=1 to 20 do 
    EditText[j] := ''; 
  EditText[1] := 'edit this text'; 
  WriteLine(1); 
  CurLine := 1; 
  CurRow := 7; 
  MoveCursor(7,1); 
  repeat 
    event(src,kod,atr); 
    if src=2 then 
      MoveCursor( kod div 20 + 1, atr div 30 + 1 ) 
    else 
      case atr of 
        0 : 
          Case kod of 
            37 : 
              MoveCursor( CurRow-1, CurLine ); 
            38 : 
              MoveCursor( CurRow, CurLine-1 ); 
            39 : 
              MoveCursor( CurRow+1, CurLine ); 
            40 : 
              MoveCursor( CurRow, CurLine+1 ); 
          end; 
        1 : 
          Case kod of 
            13 : 
              begin 
                ts := copy(EditText[CurLine],CurRow,255); 
                delete(EditText[CurLine],CurRow,255); 
                for j:=20 downto CurLine+2 do 
                  EditText[j] := EditText[j-1]; 
                EditText[CurLine+1] := ts; 
                for j:=1 to 20 do 
                  WriteLine(j); 
                MoveCursor(1,CurLine+1) 
              end; 
            8 : 
              if CurRow>1 then 
                begin 
                  delete(EditText[CurLine],CurRow-1,1); 
                  WriteLine(CurLine); 
                  MoveCursor(CurRow-1,CurLine) 
                end 
              else 
                if CurLine>1 then 
                  begin 
                    CurRow := length(EditText[CurLine-1])+1; 
                    insert(EditText[CurLine],EditText[CurLine-1],CurRow); 
                    for j:=CurLine to 19 do 
                      EditText[j] := EditText[j+1]; 
                    EditText[20] := ''; 
                    for j:=1 to 20 do 
                      WriteLine(j); 
                    MoveCursor(CurRow,CurLine-1) 
                  end; 
          end; 
        2 : 
          begin 
            insert(Chr(kod),EditText[CurLine],CurRow); 
            WriteLine(CurLine); 
            MoveCursor(CurRow+1,CurLine); 
          end; 
      end 
  until (src=1) and (kod=27) 
end.
